'Call this script with:
'> wscript.exe ping-checker.vbs (output as window default)
'> cscript.exe ping-checker.vbs (output in console)

'#####################################################################################
'# Settings
'#####################################################################################

'The name of the host from which the ping command will be send
Dim hostToPingFrom: hostToPingFrom = "localhost"

'Type of messages to report		
Dim reportOkMessage: reportOkMessage = false			'report ok message
Dim reportNokMessage: reportNokMessage = true			'report nok message

Dim logToConsole: logToConsole = true					'output to console / window
Dim sendMailMessage: sendMailMessage = false			'send reporting text mail

Dim MailFrom : MailFrom 	= "<change mail address>"	'From mailaddress
Dim MailTo : MailTo 		= "<change mail address>"	'To mailaddress
Dim SMTPServer: SMTPServer  = "<change smtp server>" 	'Name or IP of Remote SMTP Server
Dim SMTPServerPort: SMTPServerPort  = 25				'Port of the SMTP Server

'Hosts to check
Dim hostTargetsToCheck(1,3)
hostTargetsToCheck(0,0)="spacegateway1" 'The name of the target host (used in email)
hostTargetsToCheck(0,1)="192.168.88.55" 'The IP to check 			 (send ping to)
hostTargetsToCheck(0,2)="Office"        'The location from the host  (used in email)
hostTargetsToCheck(0,3)=true        	'Flag if the target should pinged


'#####################################################################################
'# End Settings
'#####################################################################################

'check all hosts in the array
For i=0 to Ubound(hostTargetsToCheck)
	if hostTargetsToCheck(i,3) then
		call SendPing(hostTargetsToCheck(i,1),hostTargetsToCheck(i,0),hostTargetsToCheck(i,2))
	End if
Next

'Send a simple text email
Function SendMail(subject,body)

  Dim oMail : Set oMail = CreateObject("CDO.Message")

  'cdoSendUsingPort
  oMail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2 
  oMail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = SMTPServerPort
  oMail.Configuration.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = SMTPServer  
  oMail.Configuration.Fields.Update

  'Mail details
  oMail.Subject = subject
  oMail.From = MailFrom
  oMail.To = MailTo
  oMail.TextBody = body
  oMail.Send

End Function

'Translate the response message code to text
Function GetResponseMessage(code)
	Select case trim(lcase(code))
		case "11001" 
		GetResponseMessage = "Buffer Too Small"
		case "11002" 
		GetResponseMessage = "Destination Net Unreachable"
		case "11003" 
		GetResponseMessage = "Destination Host Unreachable"
		case "11004" 
		GetResponseMessage = "Destination Protocol Unreachable"
		case "11005" 
		GetResponseMessage = "Destination Port Unreachable"
		case "11006" 
		GetResponseMessage = "No Resources"
		case "11007" 
		GetResponseMessage = "Bad Option"
		case "11008"
		GetResponseMessage = "Hardware Error"
		case "11009" 
		GetResponseMessage = "Packet Too Big"
		case "11010" 
		GetResponseMessage = "Request Timed Out"
		case "11011" 
		GetResponseMessage = "Bad Request"
		case "11012" 
		GetResponseMessage = "Bad Route"
		case "11013" 
		GetResponseMessage = "TimeToLive Expired Transit"
		case "11014" 
		GetResponseMessage = "TimeToLive Expired Reassembly"
		case "11015" 
		GetResponseMessage = "Parameter Problem"
		case "11016" 
		GetResponseMessage = "Source Quench"
		case "11017" 
		GetResponseMessage = "Option Too Big"
		case "11018" 
		GetResponseMessage = "Bad Destination"
		case "11032" 
		GetResponseMessage = "Negotiating IPSEC"
		case "11050" 
		GetResponseMessage = "General Failure"
		case else 
		GetResponseMessage = "Unknown Failure Code -> " & code		
	End select
End Function

'Send the standard ping message
Function SendPing(targetHostIP, targetHostName, location)
	Dim responseMessage: responseMessage =""
	Dim oPingResult	
	
	'send standard ping
	Dim cPingResults: Set cPingResults = GetObject("winmgmts:{impersonationLevel=impersonate}//" & _
			hostToPingFrom & "/root/cimv2"). ExecQuery("SELECT * FROM Win32_PingStatus " & _
			"WHERE Address = '" + targetHostIP + "'")

	'parse response
	For Each oPingResult In cPingResults
		responseMessage =""				
		
		'ping status is ok
		If oPingResult.StatusCode = 0 Then
			If LCase(targetHostIP) = oPingResult.ProtocolAddress Then
				responseMessage = targetHostIP & " is responding" & vbCrLf 
			Else
				responseMessage = "(" & oPingResult.ProtocolAddress & ") is responding" & vbCrLf 
			End If
			responseMessage = responseMessage & "Systemname " & targetHostName & vbCrLf 
			responseMessage = responseMessage & "Location " & location & vbCrLf 
			responseMessage = responseMessage & "Bytes = " & vbTab & oPingResult.BufferSize & vbCrLf 
			responseMessage = responseMessage & "Time (ms) = " & vbTab & oPingResult.ResponseTime & vbCrLf 
			responseMessage = responseMessage & "TTL (s) = " & vbTab & oPingResult.ResponseTimeToLive & vbCrLf 
			
			if reportOkMessage = true then
				If logToConsole = true then
					wscript.echo responseMessage
				End if
				If sendMailMessage = true then
					call SendMail("Ping-Checker Message",responseMessage)
				End if
			end if
		Else
			'ping status is nok
			responseMessage = targetHostIP & " is not responding" & vbCrLf 
			responseMessage = responseMessage & "Systemname " & targetHostName & vbCrLf 
			responseMessage = responseMessage & "Location " & location & vbCrLf 
			responseMessage = responseMessage & "Status code is " & oPingResult.StatusCode & vbCrLf 
			responseMessage = responseMessage & "Status message is '" & GetResponseMessage(oPingResult.StatusCode) &"'" & vbCrLf 			
			
			if reportNokMessage = true then
				If logToConsole = true then
					wscript.echo responseMessage
				End if
				If sendMailMessage = true then
					call SendMail("Ping-Checker error on system " & targetHostName,responseMessage)
				End if
			end if				
		End If
	Next
End Function